/**
 * easyWSDL - easyWSDL toolbox Platform.
 * Copyright (c) 2008,  eBM Websourcing
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the University of California, Berkeley nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.ow2.easywsdl.wsdl.decorator;

import java.util.List;
import java.util.Map;

import javax.xml.namespace.QName;

import org.ow2.easywsdl.schema.api.Documentation;
import org.ow2.easywsdl.schema.api.Element;
import org.ow2.easywsdl.schema.api.XmlException;
import org.ow2.easywsdl.schema.api.abstractElmt.AbstractSchemaElementImpl;
import org.ow2.easywsdl.wsdl.api.Part;
import org.ow2.easywsdl.wsdl.api.WSDLElement;
import org.ow2.easywsdl.wsdl.api.WSDLException;
import org.ow2.easywsdl.wsdl.api.abstractElmt.AbstractWSDLElementImpl;
import org.ow2.easywsdl.wsdl.api.abstractItf.AbsItfInput;


/**
 * @author Nicolas Salatge - eBM WebSourcing
 */
public class DecoratorInputImpl extends DecoratorParamImpl implements Decorator {

    /**
	 *
	 */
    private static final long serialVersionUID = 1L;

    protected AbsItfInput input;

    public DecoratorInputImpl(final AbsItfInput input) throws WSDLException {
    	super(input);
        this.input = input;
    }

    public Element getElement() {
        return this.input.getElement();
    }

    public QName getMessageName() {
        return this.input.getMessageName();
    }

    public String getName() {
        return this.input.getName();
    }

    public Part getPart(final String name) {
        return this.input.getPart(name);
    }

    public List<Part> getParts() {
        return this.input.getParts();
    }

    public void setElement(final Element element) throws WSDLException {
        this.input.setElement(element);
    }

    public void setMessageName(final QName name) {
        this.input.setMessageName(name);
    }

    public void setName(final String name) throws WSDLException {
        this.input.setName(name);
    }

    public Documentation createDocumentation() {
        return this.input.createDocumentation();
    }

    public Documentation getDocumentation() {
        return this.input.getDocumentation();
    }

    public Map<QName, String> getOtherAttributes() throws XmlException {
        return this.input.getOtherAttributes();
    }

    public List<org.w3c.dom.Element> getOtherElements() throws XmlException {
        return this.input.getOtherElements();
    }

    public void setDocumentation(final Documentation doc) {
        this.input.setDocumentation(doc);
    }

    @Override
	public Object getModel() {
		return ((AbstractWSDLElementImpl)this.input).getModel();
	}

    @Override
	public AbstractSchemaElementImpl getParent() {
		return ((AbstractWSDLElementImpl)this.input).getParent();
	}

	public WSDLElement getDecorator() {
		return this.input;
	}
}
